float t;
float theta, theta2;
int maxFrameCount = 150;

import peasy.*;
PeasyCam cam;

import controlP5.*;
ControlP5 cp5;

boolean toggleValue = true;
int sliderValue1 = 100;
int sliderValue2 = 100;

Table person, company;
float [][] person_searched;
float [][] company_searched;
int colP, rowP, colC, rowC;

float numRot = 25;
float numOne = 50;
float numTwo = 150;

int a = 49;
int b = 44;
int z = 0;

PShape axis;

String [] people = {"Mark Zuckerberg (Facebook)", "Peter Thiel (Founders Fund)", "Travis Kalanick (Uber)", "Steve Jobs (Apple)", "Elon Musk (Tesla)", "Ashton Kutcher (A-Grade Investments)", "Barack Obama (White House)", "Bill Gates (Microsoft)", "Jack Ma (Alibaba)", "Evan Spiegal (Snapchat)"};
String [] year = {"2012", "2013", "2014", "2015", "2016", "2017"};

PFont mono;

void setup() {
  size(displayWidth, displayHeight, P3D);
  cam = new PeasyCam(this, 1500, 2300, 0, 300);
  cam.setMinimumDistance(0);
  cam.setMaximumDistance(5000);
  cp5 = new ControlP5(this);
  cp5.setAutoDraw(false);


  cp5.addToggle("toggleValue")
    .setPosition(10, 10)
    .setSize(50, 20)
    .setLabel("Rotate")
    ;
  cp5.addSlider("sliderValue1")
    .setPosition( 10, 50)
    .setRange(0, 255)
    .setLabel("Color when company is searched less")
    ;
  cp5.addSlider("sliderValue2")
    .setPosition( 10, 100)
    .setRange(0, 255)
    .setLabel("Color when company is searched more")
    ;

  mono =  createFont("Arial Bold", 50);
  noFill();
  strokeJoin(ROUND);
  strokeCap(ROUND);
  frameRate(30);

  person = loadTable("GoogleTrends.csv", "header");
  company = loadTable("TrendsCompanies.csv", "header");
  colP = person.getColumnCount();
  rowP = person.getRowCount();
  colC = company.getColumnCount();
  rowC = company.getRowCount();

  person_searched = new float[rowP][colP];
  company_searched = new float[rowC][colC];

  for (int i = 0; i < rowP; i++) {
    for (int j = 1; j < colP; j++) {
      person_searched[i][j] = person.getFloat(i, j);
    }
  }
  //for (int i = 0; i < rowP; i++) {
  //    printArray(person_searched[i][1]);
  //}
  for (int i = 0; i < rowC; i++) {
    for (int j = 1; j < colC; j++) {
      company_searched[i][j] = company.getFloat(i, j);
    }
  }
  axis = createShape();
}

void draw() {
  //background(100, 120, 120);
  background(60);
  //background(0);
  //scale(.25);
  hint(ENABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(DISABLE_DEPTH_TEST);
  if (cp5.getWindow().isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }
  
  if(key == 'r'){
    cam.rotateY(radians(2));
  }
  else     cam.rotateY(radians(0));

  rotateX(radians(-90));

  for (int i = 0; i < 6; i++) {
    pushMatrix();
    rotateX(radians(90));
    textFont(mono);
    text(year[i], width/2 + i*220, -200, -500);
    stroke(255, 75);
    line(width/2+i*220, 0, -500, width/2+i*220, 4500, -500);
    if (i == 5) {
      line(width/2+6*220, 0, -500, width/2+6*220, 4500, -500);
    }
    for (int j =0; j <12; j++) {
      stroke(255, 5);
      line(width/2+j*220/12 + i*220, 0, -500, width/2+j*220/12 +i*220, 4500, -500);
    }
    popMatrix();
  }

  pushMatrix();
  image(1, z);
  rotateX(radians(90));
  textSize(70);
  text(people[0], -1200, 0, z);
  popMatrix();

  pushMatrix();
  image(2, z+500);
  rotateX(radians(90));
  textSize(70);
  text(people[1], -1200, 500, z);
  popMatrix();

  pushMatrix();
  image(3, z+1000);
  rotateX(radians(90));
  textSize(70);
  text(people[2], -1200, 1000, z);
  popMatrix();

  pushMatrix();
  image(4, z+1500);
  rotateX(radians(90));
  textSize(70);
  text(people[3], -1200, 1500, z);
  popMatrix();

  pushMatrix();
  image(5, z+2000);
  rotateX(radians(90));
  textSize(70);
  text(people[4], -1200, 2000, z);
  popMatrix();

  pushMatrix();
  image(6, z+2500);
  rotateX(radians(90));
  textSize(65);
  text(people[5], -1200, 2500, z);
  popMatrix();

  pushMatrix();
  image(7, z+3000);
  rotateX(radians(90));
  textSize(70);
  text(people[6], -1200, 3000, z);
  popMatrix();

  pushMatrix();
  image(8, z+3500);
  rotateX(radians(90));
  textSize(70);
  text(people[7], -1200, 3500, z);
  popMatrix();

  pushMatrix();
  image(9, z+4000);
  rotateX(radians(90));
  textSize(70);
  text(people[8], -1200, 4000, z);
  popMatrix();

  pushMatrix();
  image(10, z+4500);
  rotateX(radians(90));
  textSize(70);
  text(people[9], -1200, 4500, z);
  popMatrix();
}


void shapes(float xPos, float yPos, float zPos, float s1, float s2, float rot, float array, float company) {
  pushMatrix();
  translate(xPos, yPos, zPos);
  //translate(0,0,0);
  //color col= color(round(map(company, 0, 260, 0, xPos+25.5)), 255, 180);
  color col = color(round(map(company, 0, 100, 0, 255)), sliderValue1, sliderValue2);
  stroke(col, 200);
  rotateX(TWO_PI*(rot));
  //println(rot);
  //rotateX(TWO_PI*company*.1);
  quad( (0+numOne)*array*.1, (0+numOne)*array*.1, s2, 0, (0-numOne)*array*.1, ( 0-numOne)*array*.1, 0, s1);     
  //popMatrix();
  //pushMatrix();
  //axis.beginShape();
  // axis.stroke(0);
  // axis.strokeWeight(10);
  // line(0,yPos, zPos, xPos, yPos, zPos);
  // axis.endShape();
  popMatrix();
}